class Fahrstuhl:
    """
		Modelliert einen Fahrstuhl.
        In dieser Fassung sind nur Anforderungen im Fahrstuhl möglich.
        Erweiterungen sind möglich:
        - Anforderungen von außen
        - zwei oder mehrere koordinierte Fahrtstühle
    """

    def __init__(self):
        self.__Stockwerk: int = 0
        self.__Aufwärts: bool = True
        # Anforderungen in aktueller Fahrtrichtung
        self.__AnforderungenAktuell: List = []
        # Anforderungen entgegen aktueller Fahrtrichtung
        self.__AnforderungenGemerkt: List = []
        pass

    def get_Stockwerk(self) -> int:
        return self.__Stockwerk

    def get_Aufwärts(self) -> bool:
        return self.__Aufwärts

    def weiterfahren(self):
        """
            Weiterfahren nachdem alle Eingestiegenen ihr Zielstockwerk
            eingegeben haben.
        """
        if len(self.__AnforderungenAktuell) == 0:
            self.__AnforderungenAktuell = self.__AnforderungenGemerkt
            self.__AnforderungenGemerkt = []
            self.__Aufwärts = not self.__Aufwärts
            if self.__Aufwärts:
                self.__AnforderungenAktuell.sort()
            else:
                self.__AnforderungenAktuell.sort(reverse=True)
        if len(self.__AnforderungenAktuell) > 0:
          self.__Stockwerk = self.__AnforderungenAktuell.pop(0)

    def AnforderungInnen(self, Stockwerk: int):
        """
            Drücken eines Stockwerks im Fahrstuhl
        """
        if self.__Aufwärts:
            if Stockwerk > self.__Stockwerk:
                self.__AnforderungenAktuell.append(Stockwerk)
                self.__AnforderungenAktuell.sort()
            else:
                self.__AnforderungenGemerkt.append(Stockwerk)
        else:
            if Stockwerk < self.__Stockwerk:
                self.__AnforderungenAktuell.append(Stockwerk)
                self.__AnforderungenAktuell.sort(reverse=True)
            else:
                self.__AnforderungenGemerkt.append(Stockwerk)

