#-------------------------------------------------------------------------------
# Name:        GUIFahrstuhl.pyw
# Purpose:     2-stündiger Workshop zu GuiPy
#
# Author:      Gerhard Röhner
#
# Created:     13.09.2022
# Copyright:   (c) 2022
#-------------------------------------------------------------------------------

from PyQt6.QtWidgets import *
from PyQt6.QtGui import *
from PyQt6.QtCore import *

from Fahrstuhl import *


class Window(QMainWindow):

    def __init__(self):
        super().__init__()
        self.resize(227, 218)
        self.setWindowTitle('Fahrstuhlsimulation')
        self.setCentralWidget(QWidget(self))
        self.create_widgets()

    def create_widgets(self):
        self.leStockwerk = QLineEdit(self)
        self.leStockwerk.setGeometry(96, 32, 56, 24)
        self.leStockwerk.setText('0')
        self.lFahrstuhl = QLabel(self)
        self.lFahrstuhl.setGeometry(8, 8, 80, 24)
        self.lFahrstuhl.setText('Fahrstuhl')
        self.lFahrstuhl.setFont(QFont('MS Shell Dlg 2', 8, QFont.Weight.Bold))
        self.lAnforderunginnen = QLabel(self)
        self.lAnforderunginnen.setGeometry(8, 104, 128, 24)
        self.lAnforderunginnen.setText('Anforderung innen')
        self.lAnforderunginnen.setFont(QFont('MS Shell Dlg 2', 8, QFont.Weight.Bold))
        self.sbInnen = QSpinBox(self)
        self.sbInnen.setGeometry(24, 136, 40, 24)
        self.sbInnen.setMaximum(10)
        self.bAnfordernInnen = QPushButton(self)
        self.bAnfordernInnen.setGeometry(88, 136, 80, 24)
        self.bAnfordernInnen.setText('Anfordern')
        self.bAnfordernInnen.clicked.connect(self.bAnfordernInnen_clicked)
        self.buttonGroup2BG = QButtonGroup(self)
        self.buttonGroup2BG.setExclusive(True)
        self.sFahrstuhl = QSlider(self)
        self.sFahrstuhl.setGeometry(184, 16, 24, 184)
        self.sFahrstuhl.setOrientation(Qt.Orientation.Vertical)
        self.sFahrstuhl.setTickInterval(1)
        self.sFahrstuhl.setMaximum(10)
        self.bWeiterfahren = QPushButton(self)
        self.bWeiterfahren.setGeometry(88, 176, 80, 24)
        self.bWeiterfahren.setText('weiterfahren')
        self.bWeiterfahren.clicked.connect(self.bWeiterfahren_clicked)
        self.cbAufwaerts = QCheckBox(self)
        self.cbAufwaerts.setGeometry(24, 64, 80, 24)
        self.cbAufwaerts.setText('Aufwärts')
        self.cbAufwaerts.setChecked(True)
        self.lStockwerk = QLabel(self)
        self.lStockwerk.setGeometry(24, 32, 64, 24)
        self.lStockwerk.setText('Stockwerk')

        self.einFahrstuhl = Fahrstuhl()
        pass

    def bAnfordernInnen_clicked(self, checked):
        Stockwerk = self.sbInnen.value()
        self.einFahrstuhl.AnforderungInnen(Stockwerk)

    def bWeiterfahren_clicked(self, checked):
        self.einFahrstuhl.weiterfahren()
        Stockwerk = self.einFahrstuhl.get_Stockwerk()
        self.leStockwerk.setText(str(Stockwerk))
        self.sFahrstuhl.setValue(Stockwerk)
        self.cbAufwaerts.setChecked(self.einFahrstuhl.get_Aufwärts())

if __name__ == "__main__":
    app = QApplication([])
    window = Window()
    window.show()
    app.exec()
